<?php

/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */

class ap_Plugin
{
	/**
	 * @var	CAdminPanel
	 */
	var $_ap;
	
	/**
	 * @var	ap_PluginInfo
	 */
	var $_pluginInfo;
	
	/**
	 * @var	array
	 */
	var $_pluginIndexs;
	
	/**
	 * @var	obj
	 */
	var $_screen;
	
	/**
	 * @var	string
	 */
	var $_searchDesc = '';
	
	/**
	 * @var	bool
	 */
	var $UseGlobal = false;
	
	/**
	 * @var	bool
	 */
	var $HasGlobal = false;
	
	/**
	 * @var	array
	 */
	var $Tabs = array();
	
	/**
	 * @var	int
	 */
	var $_ptype = AP_L;
	
	/**
	 * @return	ap_Plugin
	 */
	function ap_Plugin()
	{
		if (isset($_POST['searchdesc']))
		{
			$_SESSION[AP_SESS_SEARCHDESC] = $_POST['searchdesc'];
		}
		$this->_searchDesc = isset($_SESSION[AP_SESS_SEARCHDESC]) ? $_SESSION[AP_SESS_SEARCHDESC] : '';
	}
	
	function InitScreen() {	return true; }
	
	/**
	 * @param	string	$action
	 * @param	array	$arg 
	 */
	function GlobalFunction() { return true; }

	/**
	 * @param	array	$cfg
	 * @return	bool
	 */
	function ValidateCfg() { return true; }
	
	/**
	 * @return	array
	 */
	function &GetTabs()
	{
		return $this->Tabs; 
	}
	
	/**
	 * @return	bool
	 */
	function UseGlobal()
	{
		return $this->UseGlobal;
	}
	
	/**
	 * @return	bool
	 */
	function HasGlobal()
	{
		return $this->HasGlobal;
	}

	/**
	 * @return	int
	 */
	function PType()
	{
		return $this->_ptype;
	}
	
	/**
	 * @param	CAdminPanel		$ap
	 * @param	ap_PluginInfo	$pluginInfo
	 */
	function Init(&$ap, $pluginInfo, &$pluginIndexs)
	{
		$this->_ap =& $ap;
		$this->_pluginInfo = $pluginInfo;
		$this->_pluginIndexs =& $pluginIndexs;
	}
	
	function IncludeCommon() {}
	
	function IncludeCommonOnce()
	{
		static $_mem = false;
		if (!$_mem)
		{
			$this->IncludeCommon();
			$_mem = true;
		}
	}
	
	function WriteAction() { echo 'plugin->WriteAction()'.AP_HTML_BR.AP_CRLF; }
	
	function WriteMain() { echo 'plugin->WriteMain()'.AP_HTML_BR.AP_CRLF; }
	
	function WritePop() { echo 'plugin->WriteMain()'.AP_HTML_BR.AP_CRLF; }
	
	function GetScreenName() { echo 'plugin->GetScreenName()'.AP_HTML_BR.AP_CRLF; }
	
	/**
	 * @param	string	$desc
	 */
	function _setInfo($desc)
	{
		$this->_ap->SetInfo($desc, 1);
	}
	
	/**
	 * @param	string	$desc
	 */
	function _setError($desc)
	{
		$this->_ap->SetInfo($desc, 2);
	}
	
	/**
	 * @return	string
	 */
	function PluginPath()
	{
		return $this->_pluginInfo->Path;
	}
}

class ap_PluginInfo
{
	/**
	 * @var	string
	 */
	var $Name;
	
	/**
	 * @var	string
	 */
	var $Index;
	
	/**
	 * @var	string
	 */
	var $ClassName;

	/**
	 * @var	array
	 * @example
	 * 		array(
	 * 			array('Test', 'Test Tab'),
	 * 			array('New', 'New Tab')
	 *	 	)
	 */
	var $Tabs = array();
	
	/**
	 * @var	string
	 */
	var $Version = '0.0.0';
	
	/**
	 * @var	string
	 */
	var $Path;
	
	/**
	 * @var	string
	 */
	var $UpdateIndex;
	
	/**
	 * @var int
	 */
	var $UpdateLevel = 1;
}