<?php

/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */

	$db =& DbStorageCreator::CreateDatabaseStorage($this->_settings);
	$prefix = $this->_settings->DbPrefix;
	
	$UpdateIsGood = true;
	
	$AddTableArray = array(
		DBTABLE_AWM_SENDERS,
		DBTABLE_AWM_COLUMNS,
		DBTABLE_CAL_USERS_DATA,
		DBTABLE_CAL_CALENDARS,
		DBTABLE_CAL_EVENTS,
		DBTABLE_AWM_DOMAINS,
		DBTABLE_CAL_SHARING,
		DBTABLE_CAL_PUBLICATIONS
	);
	
	$AddColumnArray = array(
		DBTABLE_AWM_ADDR_BOOK =>
			array(
				array('use_frequency', 'int(11) NOT NULL default 0', '[int] NOT NULL DEFAULT (0)'),
				array('auto_create', 'tinyint(1) NOT NULL default 0', '[bit] NOT NULL DEFAULT (0)')
			),
			
		DBTABLE_AWM_ADDR_GROUPS =>
			array(
				array('use_frequency', 'int(11) NOT NULL default 0', '[int] NOT NULL DEFAULT (0)'),
				array('email', 'varchar(255) default NULL', '[varchar] (255) NULL'),
				array('company', 'varchar(200) default NULL', '[varchar] (200) NULL'),
				array('street', 'varchar(255) default NULL', '[varchar] (255) NULL'),
				array('city', 'varchar(200) default NULL', '[varchar] (200) NULL'),
				array('state', 'varchar(200) default NULL', '[varchar] (200) NULL'),
				array('zip', 'varchar(10) default NULL', '[varchar] (10) NULL'),
				array('country', 'varchar(200) default NULL', '[varchar] (200) NULL'),
				array('phone', 'varchar(50) default NULL', '[varchar] (50) NULL'),
				array('fax', 'varchar(50) default NULL', '[varchar] (50) NULL'),
				array('web', 'varchar(255) default NULL', '[varchar] (255) NULL'),
				array('organization', 'tinyint(1) NOT NULL default 0', '[bit] NOT NULL DEFAULT (0)')
			),
			
		DBTABLE_AWM_ACCOUNTS =>
			array(
				array('id_domain', 'int(11) NOT NULL default 0', '[int] NOT NULL DEFAULT (0)'),
				array('mailing_list', 'tinyint(1) NOT NULL default 0', '[bit] NOT NULL DEFAULT (0)')
			),

		DBTABLE_CAL_SHARING =>
			array(
				array('str_to_email', 'varchar(255) NOT NULL default \'\'', '[str_to_email] [varchar] (255) NOT NULL DEFAULT (\'\')'),
			)
	);
	
	if ($db->_settings->DbType != WM_DB_MYSQL && $db->_settings->DbType != WM_DB_MSSQLSERVER)
	{
		exit('Warning: Incorrect database type.	Tables can be created in MySql or MSSql database only!');
	}
	
	if (!$db->Connect())
	{
		exit('Connect Error: '.ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL').' '.$db->GetError());
	}
	
	echo '<font color="black" size="3" style="font-family: Tahoma, Verdana;"><h3>WebMail Pro PHP Update Script:</h3>';
	$p = 0;
	
	if (count($AddTableArray) > 0)
	{
		foreach ($AddTableArray as $tabelName)
		{
			CreateTableOnUpdate($db, $tabelName, ++$p);
		}
	}
	
	echo '<br /><b>'.(++$p).'</b>. Start updating tables: <br />';
	
	foreach ($AddColumnArray As $tableName => $ColumnNames)
	{
		echo '<br /> - Update '.$prefix.$tableName.': <br />';
		if ($db->IsTableExist($prefix, $tableName))		
		{
			$oldColumns = $db->GetTablesColumns($prefix, $tableName);
			if ($oldColumns)
			{
				foreach ($ColumnNames As $AddrBookArray)
				{
					if (!in_array($AddrBookArray[0], $oldColumns))
					{
						$isGood = false;
						echo ' - add <b>'.$AddrBookArray[0].'</b> column in the table: ';
						switch ($db->_settings->DbType)
						{
							case WM_DB_MYSQL:
								$isGood = $db->_connector->Execute('ALTER TABLE `'.$prefix.$tableName.'` ADD `'.$AddrBookArray[0].'` '.$AddrBookArray[1]);
								break;	
							case WM_DB_MSSQLSERVER:
								$isGood = $db->_connector->Execute('ALTER TABLE ['.$prefix.$tableName.'] ADD ['.$AddrBookArray[0].'] '.$AddrBookArray[2]);
								break;	
						}
						
						if ($isGood)
						{
							echo ' <font color="green"><b>done!</b></font><br />';
						}
						else
						{
							$error = (strlen($db->GetError()) > 5) ? '<br />'.$db->GetError() : '';
							echo ' <font color="red"><b>error!</b>'.$db.'</font><br />';
							$UpdateIsGood = false;
						}
						
					}
					else echo '<font color="grey"> - '.$AddrBookArray[0].' column already exists in the table</font><br />';				
				}
			}
			else 
			{
				$error = (strlen($db->GetError()) > 5) ? '<br />'.$db->GetError() : '';
				echo '<font color="red"> - can\'t get '.$prefix.$tableName.' columns names'.$error.'</font><br />';
				$UpdateIsGood = false;
			}		
		}
		else 
		{
			echo '<font color="red"> - '.$prefix.$tableName.' doesn\'t exist</font><br />';
			$UpdateIsGood = false;
		}
	}
	
	echo '<br /><b>'.(++$p).'</b>. Start creating/updating indexs: <br />';
	
	$AddIndexArray = GetIndexsArray();
	$AllTables = $db->AllTableNames();
	foreach ($AddIndexArray as $tableName => $indexData) 
	{
		if (is_array($indexData))
		{
			foreach ($indexData as $fieldName) 
			{
				if ($db->CheckExistIndex($prefix, $tableName, $fieldName))
				{
					echo '<font color="grey"> - index on '.$fieldName.' already exists in '.$prefix.$tableName.' table</font><br />';
				}
				else 
				{
					if (!in_array($prefix.$tableName, $AllTables))
					{
						echo '<font color="red"> - can\'t create index for '.$fieldName.' in '.$prefix.$tableName.' table (the table doesn\'t exist)</font><br />';
					}
					else if ($db->CreateIndex($prefix, $tableName, $fieldName))
					{
						echo ' - add index on '.$fieldName.' in '.$prefix.$tableName.' table: <font color="green"><b>done!</b></font><br />';
					}
					else 
					{
						$error = (strlen($db->GetError()) > 5) ? '<br />'.$db->GetError() : '';
						echo '<font color="red"> - can\'t create index for '.$fieldName.' in '.$prefix.$tableName.' table'.$error.'</font><br />';
						$UpdateIsGood = false;
					}
				}
			}
		}
	}
	
	@$db->Disconnect();
	
	echo '<br /><b>'.(++$p).'</b>. Start updating settings.xml file: ';
	if ($db->_settings->SaveToXml())
	{
		 echo ' <font color="green"><b>done!</b></font><br />';
	}
	else
	{
		echo '<font color="red"> - can\'t update settings.xml file</font><br />';
		$UpdateIsGood = false;
	}
	
	echo ($UpdateIsGood) 
			? '<br /><br /><font color="green"><b>Update done!</b></font>' 
			: '<br /><br /><font color="red"><b>Update failed!</b></font></font>';
	
	/**
	 * @param	webmail_DbStorage	$dbStorage
	 * @param	string				$tableName
	 * @param	int					$number
	 */
	function CreateTableOnUpdate(&$dbStorage, $tableName, $number)
	{
		global $UpdateIsGood;
		
		$prefix = $dbStorage->_settings->DbPrefix;
		echo '<br /><b>'.$number.'</b>. Start creating <b>'.$prefix.$tableName.'</b> table: <br />';
	
		if (!$dbStorage->IsTableExist($prefix, $tableName))
		{
			if ($dbStorage->CreateOneTable($prefix, $tableName))
			{
				echo '<font color="green"> - '.$prefix.$tableName.' created successfully</font><br />';
			}
			else 
			{
				$error = $dbStorage->GetError();
				echo '<font color="red"> - '.$prefix.$tableName.' don\'t create '.$error.'</font><br />';
				$UpdateIsGood = false;
			}
		}
		else echo '<font color="grey"> - '.$prefix.$tableName.' already exists</font><br />';
			
	}
	