<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the proprietary AfterLogic Computer License (LICENSE.txt)
 * 
 */

	header('Content-Type: text/html; charset=utf-8');
	
	@session_name('PHPWEBMAILSESSID');
	@session_start();

	function fixed_array_map_stripslashes($array)
	{
		if (is_array($array))
		{
			foreach ($array as $key => $value)
			{
				$array[$key] = (is_array($value))
						? @fixed_array_map_stripslashes($value)
						: @stripslashes($value);
			}
		}
		return $array;
	}
	
	function disable_magic_quotes_gpc()
	{
		if (@get_magic_quotes_gpc() == 1)
		{
			$_GET = fixed_array_map_stripslashes($_GET);
			$_POST = fixed_array_map_stripslashes($_POST);
		}
	}
	
	@disable_magic_quotes_gpc();
	
	if (!defined('WM_ROOTPATH')) define('WM_ROOTPATH', (dirname(__FILE__).'/'));

	require_once(WM_ROOTPATH.'common/inc_constants.php');
	require_once(WM_ROOTPATH.'class_settings.php');
	
	$settings =& Settings::CreateInstance();
	
	if (!$settings || !$settings->isLoad)
	{
		exit('Settings Error'); //TODO: future
	} 
	else if (!$settings->IncludeLang())
	{
		exit('Language Error'); //TODO: future
	}
	
	require_once(WM_ROOTPATH.'class_account.php');
	require_once(WM_ROOTPATH.'classic/base_defines.php');
	require_once(WM_ROOTPATH.'common/class_log.php');
	
	require_once(WM_ROOTPATH.'classic/class_getmessagebase.php');
	
	$log =& CLog::CreateInstance();
	
	if (!Session::has(ACCOUNT_ID))
	{
		exit(PROC_CANT_LOAD_ACCT); //TODO: future
	}	
	
	$_SESSION['attachtempdir'] = Session::val('attachtempdir', md5(session_id()));
	$account = &Account::LoadFromDb(Session::val(ACCOUNT_ID, -1));
	
	if (!$account)
	{
		exit(PROC_CANT_LOAD_ACCT); //TODO: future
	}
	
	$_rtl = ($account->DefaultLanguage == 'Hebrew');
	$_style = ($_rtl) ? '<link rel="stylesheet" href="skins/'.$account->DefaultSkin.'/styles-rtl.css" type="text/css" id="skin-rtl">' : '';
	
	$isNull = false;

	$mes_id = Get::val('msg_id', '');
	$mes_uid = Get::val('msg_uid', '');
	$folder_id = Get::val('folder_id', '');
	$folder_name = Get::val('folder_fname', '');
	$mes_charset = Get::val('charset', -1);
	$bodytype = (int) Get::val('bodytype', 1);

	if ($mes_uid)
	{
		$GLOBALS[MIMEConst_DoNotUseMTrim] = true;
				
		$message = new GetMessageBase(	$account,
										$mes_id,
										$mes_uid,
										$folder_id ,
										$folder_name,
										$mes_charset);
										
		if (!$message->msg) 
		{
			$isNull = true;
		}
	}
	else 
	{
		$isNull = true;
	}
	
	if ($isNull)
	{
		exit(PROC_MSG_HAS_DELETED);
	}
	
	$_styleText = ' style="text-align: left;"';
	$_textCharset = ($message && $message->msg) ? $message->msg->GetTextCharset() : null;
	if (null !== $_textCharset)
	{
		if (strtolower($_textCharset) == 'iso-8859-8-i')
		{
			$_styleText = ' style="text-align: right;"';
		}
		else 
		{
			switch (ConvertUtils::GetCodePageNumber($_textCharset))
			{
				case 1255:
				case 1256:
				case 28596:
				case 28598:
					$_styleText = ' style="text-align: right;"';
					break;
				case 65001:
					if ($_rtl)
					{
						$_styleText = ' style="text-align: right;"';	
					}
					break;
			}
		}
	}
	
	$fullBodyText = ($bodytype === 1) 
		? ConvertUtils::ReplaceJSMethod($message->PrintHtmlBody(true))
		: nl2br($message->PrintPlainBody());

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" />
<html>
	<head>
		<link rel="stylesheet" href="./skins/<?php echo $account->DefaultSkin;?>/styles.css" type="text/css" />
		<?php echo $_style; ?>
	</head>
	<body class="wm_body">
		<div align="center" class="wm_space_before">
			<table class="wm_print">
				<tr>
					<td class="wm_print_title" width="60px">
					<?php echo JS_LANG_From;?>: 
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($message->PrintFrom(true)); ?>
					</td>
				</tr>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_To;?>: 
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($message->PrintTo(true)); ?>
					</td>
				</tr>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_Date;?>:
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($message->PrintDate());	?>
					</td>
				</tr>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_Subject;?>:
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($message->PrintSubject(true)); ?>
					</td>
				</tr>
				<tr>
					<td colspan="2" class="wm_print_body">
						<div class="wm_space_before"<?php echo $_styleText; ?>>
							<?php echo $fullBodyText; ?>
						</div>
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>